<?php

namespace App\Component\Role\Infrastructure;

use App\Component\Role\Domain\Role;
use App\Component\Role\Domain\RoleDataMapper;
use App\Component\Role\Domain\RoleRepository;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;
use Exception;

class RoleDatabaseAdapter extends ServiceEntityRepository implements RoleDataMapper, RoleRepository
{

    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Role::class);
    }

    public function findById(int $id): Role
    {
        $user = $this->find($id);

        if (!$user)
        {
            throw new Exception(
                'L\'utilisateur n\'existe pas'
            );
        }

        return $user;
    }

    public function findAll(): array
    {
        // TODO: Implement findAll() method.
    }
}